/* ============================================================================
Copyright (c) 2008-2014, Broadcom Corporation
All rights reserved.
Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
============================================================================ */
#ifndef GLSL_CONST_FUNCTIONS_H
#define GLSL_CONST_FUNCTIONS_H

#include "middleware/khronos/glsl/glsl_const_types.h"
#include "middleware/khronos/glsl/glsl_symbols.h"

// NOTICE! Parts of this file are AUTO-GENERATED. See Scripts/const_functions.py.
// To save your sanity, try editing that file first.


//
// Symbol table metadata.
//

// The signatures of the constant functions.

typedef enum
{
	CF_SIG__CONST_FLOAT__CONST_FLOAT,
	CF_SIG__CONST_VEC2__CONST_VEC2,
	CF_SIG__CONST_VEC3__CONST_VEC3,
	CF_SIG__CONST_VEC4__CONST_VEC4,
	CF_SIG__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF_SIG__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF_SIG__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF_SIG__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF_SIG__CONST_VEC2__CONST_VEC2__CONST_FLOAT,
	CF_SIG__CONST_VEC3__CONST_VEC3__CONST_FLOAT,
	CF_SIG__CONST_VEC4__CONST_VEC4__CONST_FLOAT,
	CF_SIG__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF_SIG__CONST_VEC2__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF_SIG__CONST_VEC3__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF_SIG__CONST_VEC4__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF_SIG__CONST_VEC2__CONST_VEC2__CONST_FLOAT__CONST_FLOAT,
	CF_SIG__CONST_VEC3__CONST_VEC3__CONST_FLOAT__CONST_FLOAT,
	CF_SIG__CONST_VEC4__CONST_VEC4__CONST_FLOAT__CONST_FLOAT,
	CF_SIG__CONST_VEC2__CONST_VEC2__CONST_VEC2__CONST_FLOAT,
	CF_SIG__CONST_VEC3__CONST_VEC3__CONST_VEC3__CONST_FLOAT,
	CF_SIG__CONST_VEC4__CONST_VEC4__CONST_VEC4__CONST_FLOAT,
	CF_SIG__CONST_VEC2__CONST_FLOAT__CONST_VEC2,
	CF_SIG__CONST_VEC3__CONST_FLOAT__CONST_VEC3,
	CF_SIG__CONST_VEC4__CONST_FLOAT__CONST_VEC4,
	CF_SIG__CONST_VEC2__CONST_FLOAT__CONST_FLOAT__CONST_VEC2,
	CF_SIG__CONST_VEC3__CONST_FLOAT__CONST_FLOAT__CONST_VEC3,
	CF_SIG__CONST_VEC4__CONST_FLOAT__CONST_FLOAT__CONST_VEC4,
	CF_SIG__CONST_FLOAT__CONST_VEC2,
	CF_SIG__CONST_FLOAT__CONST_VEC3,
	CF_SIG__CONST_FLOAT__CONST_VEC4,
	CF_SIG__CONST_FLOAT__CONST_VEC2__CONST_VEC2,
	CF_SIG__CONST_FLOAT__CONST_VEC3__CONST_VEC3,
	CF_SIG__CONST_FLOAT__CONST_VEC4__CONST_VEC4,
	CF_SIG__CONST_MAT2__CONST_MAT2__CONST_MAT2,
	CF_SIG__CONST_MAT3__CONST_MAT3__CONST_MAT3,
	CF_SIG__CONST_MAT4__CONST_MAT4__CONST_MAT4,
	CF_SIG__CONST_BVEC2__CONST_VEC2__CONST_VEC2,
	CF_SIG__CONST_BVEC3__CONST_VEC3__CONST_VEC3,
	CF_SIG__CONST_BVEC4__CONST_VEC4__CONST_VEC4,
	CF_SIG__CONST_BVEC2__CONST_IVEC2__CONST_IVEC2,
	CF_SIG__CONST_BVEC3__CONST_IVEC3__CONST_IVEC3,
	CF_SIG__CONST_BVEC4__CONST_IVEC4__CONST_IVEC4,
	CF_SIG__CONST_BVEC2__CONST_BVEC2__CONST_BVEC2,
	CF_SIG__CONST_BVEC3__CONST_BVEC3__CONST_BVEC3,
	CF_SIG__CONST_BVEC4__CONST_BVEC4__CONST_BVEC4,
	CF_SIG__CONST_BOOL__CONST_BVEC2,
	CF_SIG__CONST_BOOL__CONST_BVEC3,
	CF_SIG__CONST_BOOL__CONST_BVEC4,
	CF_SIG__CONST_BVEC2__CONST_BVEC2,
	CF_SIG__CONST_BVEC3__CONST_BVEC3,
	CF_SIG__CONST_BVEC4__CONST_BVEC4,
	CONST_FUNCTION_SIG_COUNT
} ConstFunctionSignatureIndex;

extern SymbolType constantFunctionSignatures[CONST_FUNCTION_SIG_COUNT];


// The constant functions.
typedef enum
{
	CF__RADIANS__CONST_FLOAT__CONST_FLOAT,
	CF__RADIANS__CONST_VEC2__CONST_VEC2,
	CF__RADIANS__CONST_VEC3__CONST_VEC3,
	CF__RADIANS__CONST_VEC4__CONST_VEC4,
	CF__DEGREES__CONST_FLOAT__CONST_FLOAT,
	CF__DEGREES__CONST_VEC2__CONST_VEC2,
	CF__DEGREES__CONST_VEC3__CONST_VEC3,
	CF__DEGREES__CONST_VEC4__CONST_VEC4,
	CF__SIN__CONST_FLOAT__CONST_FLOAT,
	CF__SIN__CONST_VEC2__CONST_VEC2,
	CF__SIN__CONST_VEC3__CONST_VEC3,
	CF__SIN__CONST_VEC4__CONST_VEC4,
	CF__COS__CONST_FLOAT__CONST_FLOAT,
	CF__COS__CONST_VEC2__CONST_VEC2,
	CF__COS__CONST_VEC3__CONST_VEC3,
	CF__COS__CONST_VEC4__CONST_VEC4,
	CF__TAN__CONST_FLOAT__CONST_FLOAT,
	CF__TAN__CONST_VEC2__CONST_VEC2,
	CF__TAN__CONST_VEC3__CONST_VEC3,
	CF__TAN__CONST_VEC4__CONST_VEC4,
	CF__SQRT__CONST_FLOAT__CONST_FLOAT,
	CF__SQRT__CONST_VEC2__CONST_VEC2,
	CF__SQRT__CONST_VEC3__CONST_VEC3,
	CF__SQRT__CONST_VEC4__CONST_VEC4,
	CF__INVERSESQRT__CONST_FLOAT__CONST_FLOAT,
	CF__INVERSESQRT__CONST_VEC2__CONST_VEC2,
	CF__INVERSESQRT__CONST_VEC3__CONST_VEC3,
	CF__INVERSESQRT__CONST_VEC4__CONST_VEC4,
	CF__ATAN__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__ATAN__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__ATAN__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__ATAN__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__ATAN__CONST_FLOAT__CONST_FLOAT,
	CF__ATAN__CONST_VEC2__CONST_VEC2,
	CF__ATAN__CONST_VEC3__CONST_VEC3,
	CF__ATAN__CONST_VEC4__CONST_VEC4,
	CF__ASIN__CONST_FLOAT__CONST_FLOAT,
	CF__ASIN__CONST_VEC2__CONST_VEC2,
	CF__ASIN__CONST_VEC3__CONST_VEC3,
	CF__ASIN__CONST_VEC4__CONST_VEC4,
	CF__ACOS__CONST_FLOAT__CONST_FLOAT,
	CF__ACOS__CONST_VEC2__CONST_VEC2,
	CF__ACOS__CONST_VEC3__CONST_VEC3,
	CF__ACOS__CONST_VEC4__CONST_VEC4,
	CF__POW__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__POW__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__POW__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__POW__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__EXP2__CONST_FLOAT__CONST_FLOAT,
	CF__EXP2__CONST_VEC2__CONST_VEC2,
	CF__EXP2__CONST_VEC3__CONST_VEC3,
	CF__EXP2__CONST_VEC4__CONST_VEC4,
	CF__LOG2__CONST_FLOAT__CONST_FLOAT,
	CF__LOG2__CONST_VEC2__CONST_VEC2,
	CF__LOG2__CONST_VEC3__CONST_VEC3,
	CF__LOG2__CONST_VEC4__CONST_VEC4,
	CF__EXP__CONST_FLOAT__CONST_FLOAT,
	CF__EXP__CONST_VEC2__CONST_VEC2,
	CF__EXP__CONST_VEC3__CONST_VEC3,
	CF__EXP__CONST_VEC4__CONST_VEC4,
	CF__LOG__CONST_FLOAT__CONST_FLOAT,
	CF__LOG__CONST_VEC2__CONST_VEC2,
	CF__LOG__CONST_VEC3__CONST_VEC3,
	CF__LOG__CONST_VEC4__CONST_VEC4,
	CF__ABS__CONST_FLOAT__CONST_FLOAT,
	CF__ABS__CONST_VEC2__CONST_VEC2,
	CF__ABS__CONST_VEC3__CONST_VEC3,
	CF__ABS__CONST_VEC4__CONST_VEC4,
	CF__SIGN__CONST_FLOAT__CONST_FLOAT,
	CF__SIGN__CONST_VEC2__CONST_VEC2,
	CF__SIGN__CONST_VEC3__CONST_VEC3,
	CF__SIGN__CONST_VEC4__CONST_VEC4,
	CF__FLOOR__CONST_FLOAT__CONST_FLOAT,
	CF__FLOOR__CONST_VEC2__CONST_VEC2,
	CF__FLOOR__CONST_VEC3__CONST_VEC3,
	CF__FLOOR__CONST_VEC4__CONST_VEC4,
	CF__CEIL__CONST_FLOAT__CONST_FLOAT,
	CF__CEIL__CONST_VEC2__CONST_VEC2,
	CF__CEIL__CONST_VEC3__CONST_VEC3,
	CF__CEIL__CONST_VEC4__CONST_VEC4,
	CF__FRACT__CONST_FLOAT__CONST_FLOAT,
	CF__FRACT__CONST_VEC2__CONST_VEC2,
	CF__FRACT__CONST_VEC3__CONST_VEC3,
	CF__FRACT__CONST_VEC4__CONST_VEC4,
	CF__MOD__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__MOD__CONST_VEC2__CONST_VEC2__CONST_FLOAT,
	CF__MOD__CONST_VEC3__CONST_VEC3__CONST_FLOAT,
	CF__MOD__CONST_VEC4__CONST_VEC4__CONST_FLOAT,
	CF__MOD__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__MOD__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__MOD__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__MIN__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__MIN__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__MIN__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__MIN__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__MIN__CONST_VEC2__CONST_VEC2__CONST_FLOAT,
	CF__MIN__CONST_VEC3__CONST_VEC3__CONST_FLOAT,
	CF__MIN__CONST_VEC4__CONST_VEC4__CONST_FLOAT,
	CF__MAX__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__MAX__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__MAX__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__MAX__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__MAX__CONST_VEC2__CONST_VEC2__CONST_FLOAT,
	CF__MAX__CONST_VEC3__CONST_VEC3__CONST_FLOAT,
	CF__MAX__CONST_VEC4__CONST_VEC4__CONST_FLOAT,
	CF__CLAMP__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__CLAMP__CONST_VEC2__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__CLAMP__CONST_VEC3__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__CLAMP__CONST_VEC4__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__CLAMP__CONST_VEC2__CONST_VEC2__CONST_FLOAT__CONST_FLOAT,
	CF__CLAMP__CONST_VEC3__CONST_VEC3__CONST_FLOAT__CONST_FLOAT,
	CF__CLAMP__CONST_VEC4__CONST_VEC4__CONST_FLOAT__CONST_FLOAT,
	CF__MIX__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__MIX__CONST_VEC2__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__MIX__CONST_VEC3__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__MIX__CONST_VEC4__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__MIX__CONST_VEC2__CONST_VEC2__CONST_VEC2__CONST_FLOAT,
	CF__MIX__CONST_VEC3__CONST_VEC3__CONST_VEC3__CONST_FLOAT,
	CF__MIX__CONST_VEC4__CONST_VEC4__CONST_VEC4__CONST_FLOAT,
	CF__STEP__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__STEP__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__STEP__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__STEP__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__STEP__CONST_VEC2__CONST_FLOAT__CONST_VEC2,
	CF__STEP__CONST_VEC3__CONST_FLOAT__CONST_VEC3,
	CF__STEP__CONST_VEC4__CONST_FLOAT__CONST_VEC4,
	CF__SMOOTHSTEP__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__SMOOTHSTEP__CONST_VEC2__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__SMOOTHSTEP__CONST_VEC3__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__SMOOTHSTEP__CONST_VEC4__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__SMOOTHSTEP__CONST_VEC2__CONST_FLOAT__CONST_FLOAT__CONST_VEC2,
	CF__SMOOTHSTEP__CONST_VEC3__CONST_FLOAT__CONST_FLOAT__CONST_VEC3,
	CF__SMOOTHSTEP__CONST_VEC4__CONST_FLOAT__CONST_FLOAT__CONST_VEC4,
	CF__DOT__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__DOT__CONST_FLOAT__CONST_VEC2__CONST_VEC2,
	CF__DOT__CONST_FLOAT__CONST_VEC3__CONST_VEC3,
	CF__DOT__CONST_FLOAT__CONST_VEC4__CONST_VEC4,
	CF__LENGTH__CONST_FLOAT__CONST_FLOAT,
	CF__LENGTH__CONST_FLOAT__CONST_VEC2,
	CF__LENGTH__CONST_FLOAT__CONST_VEC3,
	CF__LENGTH__CONST_FLOAT__CONST_VEC4,
	CF__DISTANCE__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__DISTANCE__CONST_FLOAT__CONST_VEC2__CONST_VEC2,
	CF__DISTANCE__CONST_FLOAT__CONST_VEC3__CONST_VEC3,
	CF__DISTANCE__CONST_FLOAT__CONST_VEC4__CONST_VEC4,
	CF__CROSS__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__NORMALIZE__CONST_FLOAT__CONST_FLOAT,
	CF__NORMALIZE__CONST_VEC2__CONST_VEC2,
	CF__NORMALIZE__CONST_VEC3__CONST_VEC3,
	CF__NORMALIZE__CONST_VEC4__CONST_VEC4,
	CF__FACEFORWARD__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__FACEFORWARD__CONST_VEC2__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__FACEFORWARD__CONST_VEC3__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__FACEFORWARD__CONST_VEC4__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__REFLECT__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__REFLECT__CONST_VEC2__CONST_VEC2__CONST_VEC2,
	CF__REFLECT__CONST_VEC3__CONST_VEC3__CONST_VEC3,
	CF__REFLECT__CONST_VEC4__CONST_VEC4__CONST_VEC4,
	CF__REFRACT__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT__CONST_FLOAT,
	CF__REFRACT__CONST_VEC2__CONST_VEC2__CONST_VEC2__CONST_FLOAT,
	CF__REFRACT__CONST_VEC3__CONST_VEC3__CONST_VEC3__CONST_FLOAT,
	CF__REFRACT__CONST_VEC4__CONST_VEC4__CONST_VEC4__CONST_FLOAT,
	CF__MATRIXCOMPMULT__CONST_MAT2__CONST_MAT2__CONST_MAT2,
	CF__MATRIXCOMPMULT__CONST_MAT3__CONST_MAT3__CONST_MAT3,
	CF__MATRIXCOMPMULT__CONST_MAT4__CONST_MAT4__CONST_MAT4,
	CF__LESSTHAN__CONST_BVEC2__CONST_VEC2__CONST_VEC2,
	CF__LESSTHAN__CONST_BVEC3__CONST_VEC3__CONST_VEC3,
	CF__LESSTHAN__CONST_BVEC4__CONST_VEC4__CONST_VEC4,
	CF__LESSTHAN__CONST_BVEC2__CONST_IVEC2__CONST_IVEC2,
	CF__LESSTHAN__CONST_BVEC3__CONST_IVEC3__CONST_IVEC3,
	CF__LESSTHAN__CONST_BVEC4__CONST_IVEC4__CONST_IVEC4,
	CF__LESSTHANEQUAL__CONST_BVEC2__CONST_VEC2__CONST_VEC2,
	CF__LESSTHANEQUAL__CONST_BVEC3__CONST_VEC3__CONST_VEC3,
	CF__LESSTHANEQUAL__CONST_BVEC4__CONST_VEC4__CONST_VEC4,
	CF__LESSTHANEQUAL__CONST_BVEC2__CONST_IVEC2__CONST_IVEC2,
	CF__LESSTHANEQUAL__CONST_BVEC3__CONST_IVEC3__CONST_IVEC3,
	CF__LESSTHANEQUAL__CONST_BVEC4__CONST_IVEC4__CONST_IVEC4,
	CF__GREATERTHAN__CONST_BVEC2__CONST_VEC2__CONST_VEC2,
	CF__GREATERTHAN__CONST_BVEC3__CONST_VEC3__CONST_VEC3,
	CF__GREATERTHAN__CONST_BVEC4__CONST_VEC4__CONST_VEC4,
	CF__GREATERTHAN__CONST_BVEC2__CONST_IVEC2__CONST_IVEC2,
	CF__GREATERTHAN__CONST_BVEC3__CONST_IVEC3__CONST_IVEC3,
	CF__GREATERTHAN__CONST_BVEC4__CONST_IVEC4__CONST_IVEC4,
	CF__GREATERTHANEQUAL__CONST_BVEC2__CONST_VEC2__CONST_VEC2,
	CF__GREATERTHANEQUAL__CONST_BVEC3__CONST_VEC3__CONST_VEC3,
	CF__GREATERTHANEQUAL__CONST_BVEC4__CONST_VEC4__CONST_VEC4,
	CF__GREATERTHANEQUAL__CONST_BVEC2__CONST_IVEC2__CONST_IVEC2,
	CF__GREATERTHANEQUAL__CONST_BVEC3__CONST_IVEC3__CONST_IVEC3,
	CF__GREATERTHANEQUAL__CONST_BVEC4__CONST_IVEC4__CONST_IVEC4,
	CF__EQUAL__CONST_BVEC2__CONST_VEC2__CONST_VEC2,
	CF__EQUAL__CONST_BVEC3__CONST_VEC3__CONST_VEC3,
	CF__EQUAL__CONST_BVEC4__CONST_VEC4__CONST_VEC4,
	CF__EQUAL__CONST_BVEC2__CONST_IVEC2__CONST_IVEC2,
	CF__EQUAL__CONST_BVEC3__CONST_IVEC3__CONST_IVEC3,
	CF__EQUAL__CONST_BVEC4__CONST_IVEC4__CONST_IVEC4,
	CF__EQUAL__CONST_BVEC2__CONST_BVEC2__CONST_BVEC2,
	CF__EQUAL__CONST_BVEC3__CONST_BVEC3__CONST_BVEC3,
	CF__EQUAL__CONST_BVEC4__CONST_BVEC4__CONST_BVEC4,
	CF__NOTEQUAL__CONST_BVEC2__CONST_VEC2__CONST_VEC2,
	CF__NOTEQUAL__CONST_BVEC3__CONST_VEC3__CONST_VEC3,
	CF__NOTEQUAL__CONST_BVEC4__CONST_VEC4__CONST_VEC4,
	CF__NOTEQUAL__CONST_BVEC2__CONST_IVEC2__CONST_IVEC2,
	CF__NOTEQUAL__CONST_BVEC3__CONST_IVEC3__CONST_IVEC3,
	CF__NOTEQUAL__CONST_BVEC4__CONST_IVEC4__CONST_IVEC4,
	CF__NOTEQUAL__CONST_BVEC2__CONST_BVEC2__CONST_BVEC2,
	CF__NOTEQUAL__CONST_BVEC3__CONST_BVEC3__CONST_BVEC3,
	CF__NOTEQUAL__CONST_BVEC4__CONST_BVEC4__CONST_BVEC4,
	CF__ANY__CONST_BOOL__CONST_BVEC2,
	CF__ANY__CONST_BOOL__CONST_BVEC3,
	CF__ANY__CONST_BOOL__CONST_BVEC4,
	CF__ALL__CONST_BOOL__CONST_BVEC2,
	CF__ALL__CONST_BOOL__CONST_BVEC3,
	CF__ALL__CONST_BOOL__CONST_BVEC4,
	CF__NOT__CONST_BVEC2__CONST_BVEC2,
	CF__NOT__CONST_BVEC3__CONST_BVEC3,
	CF__NOT__CONST_BVEC4__CONST_BVEC4,
	CONST_FUNCTION_COUNT
} ConstFunctionIndex;

extern Symbol constantFunctions[CONST_FUNCTION_COUNT];


// Populate a symbol table with the constant functions, initializing the arrays iff necessary.
void glsl_populate_with_const_functions(SymbolTable* symbol_table);

#endif // CONST_FUNCTIONS_H