/* ============================================================================
Copyright (c) 2008-2014, Broadcom Corporation
All rights reserved.
Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
============================================================================ */
#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define yy_create_buffer pp_create_buffer
#define yy_delete_buffer pp_delete_buffer
#define yy_flex_debug pp_flex_debug
#define yy_init_buffer pp_init_buffer
#define yy_flush_buffer pp_flush_buffer
#define yy_load_buffer_state pp_load_buffer_state
#define yy_switch_to_buffer pp_switch_to_buffer
#define yyin ppin
#define yyleng ppleng
#define yylex pplex
#define yylineno pplineno
#define yyout ppout
#define yyrestart pprestart
#define yytext pptext
#define yywrap ppwrap
#define yyalloc ppalloc
#define yyrealloc pprealloc
#define yyfree ppfree

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

#ifdef __CC_ARM
#ifndef ANDROID
#include "mobcom_types.h"
#include "file.h"
#define	getc		FS_Getc
#define EINTR		4
#endif
#endif

/* end standard C headers. */

/* flex integer type definitions */

#ifndef LEX_YY_C
#define LEX_YY_C

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types.
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t;
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;
#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE pprestart(ppin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE 16384
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int ppleng;

extern FILE *ppin, *ppout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    #define YY_LESS_LINENO(n)

/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up pptext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up pptext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via pprestart()), so that the user can continue scanning by
	 * just pointing ppin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when pptext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int ppleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow ppwrap()'s to do buffer switches
 * instead of setting up a fresh ppin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void pprestart (FILE *input_file  );
void pp_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE pp_create_buffer (FILE *file,int size  );
void pp_delete_buffer (YY_BUFFER_STATE b  );
void pp_flush_buffer (YY_BUFFER_STATE b  );
void pppush_buffer_state (YY_BUFFER_STATE new_buffer  );
void pppop_buffer_state (void );

static void ppensure_buffer_stack (void );
static void pp_load_buffer_state (void );
static void pp_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER pp_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE pp_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE pp_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE pp_scan_bytes (yyconst char *bytes,int len  );

void *ppalloc (yy_size_t  );
void *pprealloc (void *,yy_size_t  );
void ppfree (void *  );

#define yy_new_buffer pp_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        ppensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            pp_create_buffer(ppin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        ppensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            pp_create_buffer(ppin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

typedef unsigned char YY_CHAR;

FILE *ppin = (FILE *) 0, *ppout = (FILE *) 0;

typedef int yy_state_type;

extern int pplineno;

int pplineno = 1;

extern char *pptext;
#define yytext_ptr pptext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up pptext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	ppleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 183
#define YY_END_OF_BUFFER 184
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[578] =
    {   0,
        0,    0,  178,  178,  184,  182,    2,    3,    4,   93,
        1,  182,   99,  104,   82,   83,   97,   96,   89,   94,
       88,   98,  173,  173,   90,   92,  100,   91,  101,  105,
      175,   84,   85,  103,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,   86,  102,   87,   95,  178,  180,
      179,    2,   68,    0,   75,   69,   78,   72,   63,   74,
       64,   81,  172,  177,  176,   73,  172,  173,  174,  174,
      174,  174,  174,  173,   61,   65,   67,   66,   62,  175,
       79,   71,  175,  175,  175,  175,  175,  175,  175,  175,

      175,  175,  175,   28,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,   31,   46,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,   80,
       70,  178,  179,  179,  181,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  172,  174,  176,  172,  174,  172,
      173,  173,   76,   77,   16,  121,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,   30,  175,

      175,  175,  175,  175,  175,  175,  175,  175,  175,   25,
      175,  175,  175,  175,  175,  175,  175,  175,  175,   47,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      174,  172,  175,   23,  175,  175,  167,  175,  175,  175,
      175,  175,  175,  175,  175,  175,    9,   29,  175,  175,
      124,  175,  175,  175,  175,  140,  175,  175,  129,  144,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,

       15,  141,   59,   43,   44,   45,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  127,  170,  175,  175,  175,  175,
      175,  175,  175,   40,   41,   42,  175,   54,  175,   19,
      175,    0,    0,    0,    0,  120,  119,    0,  111,    0,
        0,    0,    0,  175,   26,   34,   35,   36,  122,   22,
      175,  175,  175,  175,  175,  175,  153,  154,  155,  175,
       10,   11,  175,  175,  171,  145,   24,  156,  157,  158,
       57,  150,  151,  152,    7,  175,  175,   48,  148,  175,
      175,   37,   38,   39,  175,  175,  175,  175,  175,  175,

      175,  175,  175,  175,  175,  142,  175,  175,  175,  175,
      175,  175,  175,    6,  175,  123,  175,  169,  175,  175,
      175,   55,  114,  113,    0,  112,    0,    0,  116,    0,
        0,  175,  175,  175,    5,  175,  175,  143,   18,  175,
      137,    8,  132,  175,  175,  175,  175,  175,  149,  128,
       12,  175,  135,  175,   33,  175,  166,  136,   53,  147,
      130,  175,  175,  175,  175,  175,  175,  175,  115,    0,
      110,    0,  117,  175,  175,  131,   20,   32,  175,  175,
      175,  175,   58,  175,  175,  175,   17,  175,  175,  125,
       49,  175,   50,   14,  175,    0,    0,  175,   27,  175,

      138,  175,  175,  175,  133,  175,  175,  175,  175,  175,
      126,  146,  134,  118,    0,   21,   13,  139,   56,  168,
       60,  159,   51,  160,  175,    0,  175,  175,  175,  175,
      175,    0,    0,  175,  175,  175,  175,   52,    0,    0,
      175,  175,  175,  175,    0,    0,  175,  163,  175,  164,
        0,    0,    0,  175,  175,  175,    0,    0,    0,  161,
      175,  162,    0,  107,    0,    0,  175,  106,    0,    0,
      175,    0,  109,  175,  108,  165,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    5,    1,    6,    7,    8,    9,    1,   10,
       11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
       21,   22,   23,   23,   23,   24,   24,   25,   26,   27,
       28,   29,   30,    1,   31,   31,   32,   33,   34,   31,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   36,
       35,   37,   38,   35,   35,   35,   35,   39,   35,   35,
       40,    1,   41,   42,   43,    1,   44,   45,   46,   47,

       48,   49,   50,   51,   52,   35,   53,   54,   55,   56,
       57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
       67,   68,   69,   70,   71,   72,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[73] =
    {   0,
        1,    1,    2,    1,    1,    1,    1,    1,    1,    1,
        1,    3,    1,    1,    1,    4,    1,    5,    5,    5,
        5,    5,    5,    5,    1,    1,    1,    1,    1,    1,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    1,
        1,    1,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    1,    1,
        1,    1
    } ;

static yyconst flex_int16_t yy_base[584] =
    {   0,
        0,    0,   70,   71,  722,  723,  719,  723,  723,  692,
      723,  712,  690,   66,  723,  723,  689,   63,  723,   62,
       77,   75,   88,  139,  723,  723,   51,  688,   52,  723,
        0,  723,  723,   60,   59,   29,   61,   71,   77,   88,
      658,   86,   85,   87,   81,  107,  651,  109,  665,  126,
      123,  120,  136,  135,  723,   56,  723,  723,    0,  723,
      182,  710,  723,  152,  723,  723,  723,  723,  723,  723,
      723,  723,  199,  723,    0,  723,  206,  216,  230,  207,
      253,  244,  285,    0,  683,  723,  723,  723,  682,    0,
      723,  723,  655,  653,  645,  649,  657,  656,  642,  658,

      645,  651,  638,  635,  649,   95,  148,  636,  633,  640,
      627,  152,  632,  643,  628,  635,  638,  639,  211,  227,
      638,  629,  204,  622,  636,  627,  629,  618,  633,  198,
      633,   55,  622,  619,  607,  122,  616,  621,  617,  619,
      607,  611,  209,  616,  607,  156,  113,  606,  613,  723,
      723,    0,  193,  271,  723,  616,  597,  608,  604,  238,
      612,  218,  607,  184,    0,  322,    0,  275,  297,  298,
        0,  307,  723,  723,    0,    0,  598,  603,  612,  609,
      592,  592,  142,  271,  280,  607,  605,  601,  601,  603,
      595,  591,  588,  596,  582,  594,  579,  596,    0,  593,

      581,  588,  585,  589,  586,  586,  580,  568,  567,  581,
      584,  581,  578,  575,  566,  327,  571,  574,  565,  562,
      566,  568,  571,  562,  552,  551,  555,  552,  563,  548,
      546,  560,  545,  548,  544,  556,  555,  554,  279,  549,
      544,  532,  330,  537,  550,  552,  539,  540,  541,  534,
      534,  540,  523,  532,  543,  528,  526,  534,  517,  519,
      312,  340,  529,    0,  527,  336,    0,  518,  516,  525,
      513,  519,  529,  529,  518,  339,    0,    0,  517,  521,
        0,  509,  306,  520,  520,    0,  504,  343,    0,    0,
      507,  347,  515,  515,  506,  499,  498,  499,  498,  350,

        0,    0,    0,    0,    0,    0,  494,  495,  501,  491,
      505,  497,  499,  498,  497,  488,  493,  484,  488,  492,
      497,  482,  495,  486,    0,    0,  492,  489,  480,  480,
      485,  484,  481,    0,    0,    0,  480,    0,  469,    0,
      482,  475,  508,  470,  506,  723,  723,  465,  723,  464,
      467,  460,  465,  475,    0,    0,    0,    0,    0,    0,
      463,  464,  469,  462,  455,  466,    0,    0,    0,  465,
        0,    0,  451,  455,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,  461,  461,    0,    0,  459,
      455,    0,    0,    0,  451,  447,  452,  441,  455,  457,

      439,  453,  438,  441,  448,    0,  446,  448,  431,  434,
      440,  446,  441,    0,  428,    0,  431,    0,  430,  428,
      432,    0,  723,  723,  423,  723,  434,  419,  723,  417,
      433,  415,  414,  414,    0,  427,  427,    0,    0,  421,
      428,    0,    0,  427,  426,  411,  424,  411,    0,    0,
        0,  414,    0,  417,    0,  404,    0,    0,    0,    0,
        0,  401,  413,  406,  412,  409,  402,  403,  723,  395,
      723,  395,  723,  392,  405,    0,    0,    0,  395,  397,
      404,  393,    0,  402,  399,  389,    0,  354,  397,    0,
        0,  397,    0,    0,  395,  380,  393,  392,    0,  383,

        0,  390,  375,  388,    0,  379,  401,  400,  399,  368,
        0,    0,    0,  723,  387,    0,    0,    0,    0,    0,
        0,  391,  225,  391,  382,  334,  375,  377,  373,  375,
      374,  374,  357,  375,  372,  373,  370,    0,  372,  369,
      366,  350,  364,  348,  331,  358,  344,  359,  339,    0,
      332,  326,  339,  316,  328,  312,  295,  291,  333,    0,
      277,    0,  253,  723,  248,  229,  198,  723,  187,  138,
      111,   87,  723,   51,  723,    0,  723,  387,  389,   80,
      394,  399,  404
    } ;

static yyconst flex_int16_t yy_def[584] =
    {   0,
      577,    1,  578,  578,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  579,  579,  577,  577,  577,  577,  577,  577,
      580,  577,  577,  577,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  577,  577,  577,  577,  581,  577,
      582,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,   24,  577,  583,  577,   73,   24,   24,  579,
       73,  579,   73,   24,  577,  577,  577,  577,  577,  580,
      577,  577,  580,  580,  580,  580,  580,  580,  580,  580,

      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  577,
      577,  581,  582,  582,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,   73,   81,  583,   73,   81,   81,
       83,   83,  577,  577,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,

      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      166,  166,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,

      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,

      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  577,  577,
      577,  577,  577,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  577,  577,  580,  580,  580,

      580,  580,  580,  580,  580,  580,  580,  580,  580,  580,
      580,  580,  580,  577,  577,  580,  580,  580,  580,  580,
      580,  580,  580,  580,  580,  577,  580,  580,  580,  580,
      580,  577,  577,  580,  580,  580,  580,  580,  577,  577,
      580,  580,  580,  580,  577,  577,  580,  580,  580,  580,
      577,  577,  577,  580,  580,  580,  577,  577,  577,  580,
      580,  580,  577,  577,  577,  577,  580,  577,  577,  577,
      580,  577,  577,  580,  577,  580,    0,  577,  577,  577,
      577,  577,  577
    } ;

static yyconst flex_int16_t yy_nxt[796] =
    {   0,
        6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
       16,   17,   18,   19,   20,   21,   22,   23,   24,   24,
       24,   24,   24,   24,   25,   26,   27,   28,   29,   30,
       31,   31,   31,   31,   31,   31,   31,   31,   31,   32,
       33,   34,   31,   35,   36,   37,   38,   39,   40,   41,
       42,   43,   31,   44,   45,   46,   47,   48,   31,   49,
       50,   51,   52,   53,   54,   31,   31,   31,   55,   56,
       57,   58,   60,   60,   66,   69,   71,   85,   86,   88,
       89,   61,   61,  150,   90,   96,   74,   91,   97,   72,
       70,   75,   98,   67,   73,   73,   73,   73,   73,   73,

       73,   92,   76,   77,   99,   78,   78,   78,   78,   78,
       78,   79,   93,  225,  100,  576,  226,  101,  102,   94,
       95,   81,  103,   82,  124,  151,   83,  104,  125,  116,
      106,  110,  107,  119,  105,   81,  108,  117,  122,  111,
      120,  112,  109,  123,  113,   82,  188,  575,  121,  118,
      126,  114,  129,   83,   77,  189,   84,   84,   84,   84,
       84,   84,   84,  127,  245,  230,  246,  574,  130,  133,
      139,  131,   81,  140,   82,  143,  134,  135,  148,  145,
      144,  231,  141,  146,  573,  149,   81,  136,  137,  142,
      138,  190,  147,  154,  191,  197,   82,  156,  155,  157,

      158,  243,  269,  270,  577,  159,  160,  161,  198,  577,
      192,  162,  163,  164,   80,  244,  165,  165,  165,  165,
      165,  165,  165,  168,  168,  168,  168,  168,  168,  168,
      572,  259,  166,   78,   78,   78,   78,   78,   78,   79,
       82,  222,   82,  260,  571,  223,  166,   79,   79,   79,
       79,   79,   79,   79,   82,  238,   80,  205,   80,  214,
      239,  528,  529,  256,   82,  169,  206,  169,  215,  240,
      170,  170,  170,  170,  170,  170,  170,   82,  257,   82,
      207,  253,  154,  208,  209,  570,   82,  155,  210,  254,
      211,   82,  168,  168,  168,  168,  168,  168,  168,  569,

       82,   82,  171,  171,  171,  171,  171,  171,  171,  577,
      577,  577,  577,  568,  271,  171,  171,  171,  172,   80,
      567,   80,  272,  273,  577,  274,  577,  329,  171,  171,
      171,  171,  172,  171,  261,  330,  261,  564,  563,  262,
      262,  262,  262,  262,  262,  262,  304,  305,  306,  334,
      335,  336,  577,  532,  577,  356,  357,  358,  367,  368,
      369,  373,  378,  379,  380,  374,  382,  383,  384,  392,
      393,  394,  507,  508,  509,  551,  562,  565,  561,  533,
      560,  559,  558,  557,  552,  510,  566,   59,   59,   59,
       59,   59,   80,   80,  152,  556,  555,  152,  152,  153,

      554,  153,  153,  153,  167,  553,  167,  167,  167,  550,
      549,  548,  547,  546,  545,  544,  543,  542,  541,  540,
      539,  538,  537,  536,  535,  534,  531,  530,  527,  526,
      525,  524,  523,  522,  521,  520,  519,  518,  517,  516,
      515,  514,  513,  512,  511,  506,  505,  504,  503,  502,
      501,  500,  499,  498,  497,  496,  495,  494,  493,  492,
      491,  490,  489,  488,  487,  486,  485,  484,  483,  482,
      481,  480,  479,  478,  477,  476,  475,  474,  473,  472,
      471,  470,  469,  468,  467,  466,  465,  464,  463,  462,
      461,  460,  459,  458,  457,  456,  455,  454,  453,  452,

      451,  450,  449,  448,  447,  446,  445,  444,  443,  442,
      441,  440,  439,  438,  437,  436,  435,  434,  433,  432,
      431,  430,  429,  428,  427,  426,  425,  424,  423,  422,
      421,  420,  419,  418,  417,  416,  415,  414,  413,  412,
      411,  410,  409,  408,  407,  406,  405,  404,  403,  402,
      401,  400,  399,  398,  397,  396,  395,  391,  390,  389,
      388,  387,  386,  385,  381,  377,  376,  375,  372,  371,
      370,  366,  365,  364,  363,  362,  361,  360,  359,  355,
      354,  353,  352,  351,  350,  349,  348,  347,  346,  345,
      344,  343,  342,  341,  340,  339,  338,  337,  333,  332,

      331,  328,  327,  326,  325,  324,  323,  322,  321,  320,
      319,  318,  317,  316,  315,  314,  313,  312,  311,  310,
      309,  308,  307,  303,  302,  301,  300,  299,  298,  297,
      296,  295,  294,  293,  292,  291,  290,  289,  288,  287,
      286,  285,  284,  283,  282,  281,  280,  279,  278,  277,
      276,  275,  268,  267,  266,  265,  264,  263,  258,  255,
      252,  251,  250,  249,  248,  247,  242,  241,  237,  236,
      235,  234,  233,  232,  229,  228,  227,  224,  221,  220,
      219,  218,  217,  216,  213,  212,  204,  203,  202,  201,
      200,  199,  196,  195,  194,  193,  187,  186,  185,  184,

      183,  182,  181,  180,  179,  178,  177,  176,  175,  174,
      173,   62,  132,  128,  115,   87,   68,   65,   64,   63,
       62,  577,    5,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577

    } ;

static yyconst flex_int16_t yy_chk[796] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    3,    4,   14,   18,   20,   27,   27,   29,
       29,    3,    4,   56,  580,   36,   22,   34,   36,   20,
       18,   22,   36,   14,   21,   21,   21,   21,   21,   21,

       21,   34,   22,   23,   37,   23,   23,   23,   23,   23,
       23,   23,   35,  132,   37,  574,  132,   37,   38,   35,
       35,   23,   38,   23,   45,   56,   23,   38,   45,   42,
       39,   40,   39,   43,   38,   23,   39,   42,   44,   40,
       43,   40,   39,   44,   40,   23,  106,  572,   43,   42,
       46,   40,   48,   23,   24,  106,   24,   24,   24,   24,
       24,   24,   24,   46,  147,  136,  147,  571,   48,   50,
       51,   48,   24,   51,   24,   52,   50,   50,   54,   53,
       52,  136,   51,   53,  570,   54,   24,   50,   50,   51,
       50,  107,   53,   61,  107,  112,   24,   64,   61,   64,

       64,  146,  183,  183,  153,   64,   64,   64,  112,  153,
      107,   64,   64,   64,   73,  146,   73,   73,   73,   73,
       73,   73,   73,   77,   77,   77,   77,   77,   77,   77,
      569,  164,   73,   78,   78,   78,   78,   78,   78,   78,
       80,  130,   80,  164,  567,  130,   73,   79,   79,   79,
       79,   79,   79,   79,   80,  143,   82,  119,   82,  123,
      143,  523,  523,  162,   80,   81,  119,   81,  123,  143,
       81,   81,   81,   81,   81,   81,   81,   82,  162,   82,
      120,  160,  154,  120,  120,  566,   81,  154,  120,  160,
      120,   82,  168,  168,  168,  168,  168,  168,  168,  565,

       81,   82,   83,   83,   83,   83,   83,   83,   83,  169,
      170,  169,  170,  563,  184,   83,   83,   83,   83,  172,
      561,  172,  184,  185,  261,  185,  261,  239,   83,   83,
       83,   83,   83,   83,  166,  239,  166,  558,  557,  166,
      166,  166,  166,  166,  166,  166,  216,  216,  216,  243,
      243,  243,  262,  526,  262,  266,  266,  266,  276,  276,
      276,  283,  288,  288,  288,  283,  292,  292,  292,  300,
      300,  300,  488,  488,  488,  545,  556,  559,  555,  526,
      554,  553,  552,  551,  545,  488,  559,  578,  578,  578,
      578,  578,  579,  579,  581,  549,  548,  581,  581,  582,

      547,  582,  582,  582,  583,  546,  583,  583,  583,  544,
      543,  542,  541,  540,  539,  537,  536,  535,  534,  533,
      532,  531,  530,  529,  528,  527,  525,  524,  522,  515,
      510,  509,  508,  507,  506,  504,  503,  502,  500,  498,
      497,  496,  495,  492,  489,  486,  485,  484,  482,  481,
      480,  479,  475,  474,  472,  470,  468,  467,  466,  465,
      464,  463,  462,  456,  454,  452,  448,  447,  446,  445,
      444,  441,  440,  437,  436,  434,  433,  432,  431,  430,
      428,  427,  425,  421,  420,  419,  417,  415,  413,  412,
      411,  410,  409,  408,  407,  405,  404,  403,  402,  401,

      400,  399,  398,  397,  396,  395,  391,  390,  387,  386,
      374,  373,  370,  366,  365,  364,  363,  362,  361,  354,
      353,  352,  351,  350,  348,  345,  344,  343,  342,  341,
      339,  337,  333,  332,  331,  330,  329,  328,  327,  324,
      323,  322,  321,  320,  319,  318,  317,  316,  315,  314,
      313,  312,  311,  310,  309,  308,  307,  299,  298,  297,
      296,  295,  294,  293,  291,  287,  285,  284,  282,  280,
      279,  275,  274,  273,  272,  271,  270,  269,  268,  265,
      263,  260,  259,  258,  257,  256,  255,  254,  253,  252,
      251,  250,  249,  248,  247,  246,  245,  244,  242,  241,

      240,  238,  237,  236,  235,  234,  233,  232,  231,  230,
      229,  228,  227,  226,  225,  224,  223,  222,  221,  220,
      219,  218,  217,  215,  214,  213,  212,  211,  210,  209,
      208,  207,  206,  205,  204,  203,  202,  201,  200,  198,
      197,  196,  195,  194,  193,  192,  191,  190,  189,  188,
      187,  186,  182,  181,  180,  179,  178,  177,  163,  161,
      159,  158,  157,  156,  149,  148,  145,  144,  142,  141,
      140,  139,  138,  137,  135,  134,  133,  131,  129,  128,
      127,  126,  125,  124,  122,  121,  118,  117,  116,  115,
      114,  113,  111,  110,  109,  108,  105,  104,  103,  102,

      101,  100,   99,   98,   97,   96,   95,   94,   93,   89,
       85,   62,   49,   47,   41,   28,   17,   13,   12,   10,
        7,    5,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577,  577,  577,  577,  577,  577,
      577,  577,  577,  577,  577

    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int pp_flex_debug;
int pp_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *pptext;
   // build me with "flex -L -Ppp -olex.yy.c --never-interactive shader.l"
   // and delete the bogus #line directive at the start
   // --never-interactive is to avoid isatty declaration issues with c++

   #include "middleware/khronos/glsl/glsl_common.h"
   #include "middleware/khronos/glsl/glsl_errors.h"
   #include "middleware/khronos/glsl/glsl_intern.h"

   #include "middleware/khronos/glsl/prepro/glsl_prepro_directive.h"
   #include "middleware/khronos/glsl/prepro/glsl_prepro_token.h"

   #include "middleware/khronos/glsl/glsl_globals.h"
   #include "middleware/khronos/glsl/glsl_const_functions.h"
   #include "middleware/khronos/glsl/glsl_header.h"

   #include <stdlib.h>
   #include <string.h>

   TokenData pptoken;

   extern void yyerror(char *c);

   /*
      disable unreachable code warning (break after return)
   */

#ifndef WIN32
#pragma off warn
#endif
#define YY_NO_UNISTD_H 1

#define INITIAL 0
#define comment 1

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int pplex_destroy (void );

int ppget_debug (void );

void ppset_debug (int debug_flag  );

YY_EXTRA_TYPE ppget_extra (void );

void ppset_extra (YY_EXTRA_TYPE user_defined  );

FILE *ppget_in (void );

void ppset_in  (FILE * in_str  );

FILE *ppget_out (void );

void ppset_out  (FILE * out_str  );

int ppget_leng (void );

char *ppget_text (void );

int ppget_lineno (void );

void ppset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int ppwrap (void );
#else
extern int ppwrap (void );
#endif
#endif

    static void yyunput (int c,char *buf_ptr  );

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO fwrite( pptext, ppleng, 1, ppout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( ppin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( ppin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, ppin))==0 && ferror(ppin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(ppin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int pplex (void);

#define YY_DECL int pplex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after pptext and ppleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;

   BEGIN INITIAL;

   /*
      tokens for the preprocessor

      HASH
      WHITESPACE
      NEWLINE

      DEFINE
      UNDEF
      IFDEF
      IFNDEF
      ELIF
      ENDIF
      ERROR
      PRAGMA
      EXTENSION
      VERSION
      LINE

      ALL
      REQUIRE
      ENABLE
      WARN
      DISABLE
   */

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! ppin )
			ppin = stdin;

		if ( ! ppout )
			ppout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			ppensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				pp_create_buffer(ppin,YY_BUF_SIZE );
		}

		pp_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of pptext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 578 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 723 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
return HASH;
	YY_BREAK
case 2:
YY_RULE_SETUP
return WHITESPACE;
	YY_BREAK
case 3:
/* rule 3 can match eol */
YY_RULE_SETUP
{
                  g_LineNumber++;
                  return NEWLINE;
               }
	YY_BREAK
case 4:
YY_RULE_SETUP
;
	YY_BREAK
case 5:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("define", false); return DEFINE; }
	YY_BREAK
case 6:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("undef", false); return UNDEF; }
	YY_BREAK
case 7:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("ifdef", false); return IFDEF; }
	YY_BREAK
case 8:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("ifndef", false); return IFNDEF; }
	YY_BREAK
case 9:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("elif", false); return ELIF; }
	YY_BREAK
case 10:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("endif", false); return ENDIF; }
	YY_BREAK
case 11:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("error", false); return ERROR; }
	YY_BREAK
case 12:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("pragma", false); return PRAGMA; }
	YY_BREAK
case 13:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("extension", false); return EXTENSION; }
	YY_BREAK
case 14:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("version", false); return VERSION; }
	YY_BREAK
case 15:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("line", false); return LINE; }
	YY_BREAK
case 16:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("all", false); return ALL; }
	YY_BREAK
case 17:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("require", false); return REQUIRE; }
	YY_BREAK
case 18:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("enable", false); return ENABLE; }
	YY_BREAK
case 19:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("warn", false); return WARN; }
	YY_BREAK
case 20:
YY_RULE_SETUP
{ pptoken.s = glsl_intern("disable", false); return DISABLE; }
	YY_BREAK
/*
      tokens for the shading language itself (keywords)

      ATTRIBUTE CONST BOOL FLOAT INT
      BREAK CONTINUE DO ELSE FOR IF DISCARD RETURN
      BVEC2 BVEC3 BVEC4 IVEC2 IVEC3 IVEC4 VEC2 VEC3 VEC4
      MAT2 MAT3 MAT4 IN OUT INOUT UNIFORM VARYING
      SAMPLER2D SAMPLERCUBE
      STRUCT VOID WHILE
      INVARIANT
      HIGH_PRECISION MEDIUM_PRECISION LOW_PRECISION PRECISION
   */
case 21:
YY_RULE_SETUP
return ATTRIBUTE;
	YY_BREAK
case 22:
YY_RULE_SETUP
return CONST;
	YY_BREAK
case 23:
YY_RULE_SETUP
return BOOL;
	YY_BREAK
case 24:
YY_RULE_SETUP
return FLOAT;
	YY_BREAK
case 25:
YY_RULE_SETUP
return _INT;
	YY_BREAK
case 26:
YY_RULE_SETUP
return BREAK;
	YY_BREAK
case 27:
YY_RULE_SETUP
return CONTINUE;
	YY_BREAK
case 28:
YY_RULE_SETUP
return DO;
	YY_BREAK
case 29:
YY_RULE_SETUP
return ELSE;
	YY_BREAK
case 30:
YY_RULE_SETUP
return FOR;
	YY_BREAK
case 31:
YY_RULE_SETUP
return IF;
	YY_BREAK
case 32:
YY_RULE_SETUP
return DISCARD;
	YY_BREAK
case 33:
YY_RULE_SETUP
return RETURN;
	YY_BREAK
case 34:
YY_RULE_SETUP
return BVEC2;
	YY_BREAK
case 35:
YY_RULE_SETUP
return BVEC3;
	YY_BREAK
case 36:
YY_RULE_SETUP
return BVEC4;
	YY_BREAK
case 37:
YY_RULE_SETUP
return IVEC2;
	YY_BREAK
case 38:
YY_RULE_SETUP
return IVEC3;
	YY_BREAK
case 39:
YY_RULE_SETUP
return IVEC4;
	YY_BREAK
case 40:
YY_RULE_SETUP
return VEC2;
	YY_BREAK
case 41:
YY_RULE_SETUP
return VEC3;
	YY_BREAK
case 42:
YY_RULE_SETUP
return VEC4;
	YY_BREAK
case 43:
YY_RULE_SETUP
return MAT2;
	YY_BREAK
case 44:
YY_RULE_SETUP
return MAT3;
	YY_BREAK
case 45:
YY_RULE_SETUP
return MAT4;
	YY_BREAK
case 46:
YY_RULE_SETUP
return IN;
	YY_BREAK
case 47:
YY_RULE_SETUP
return OUT;
	YY_BREAK
case 48:
YY_RULE_SETUP
return INOUT;
	YY_BREAK
case 49:
YY_RULE_SETUP
return UNIFORM;
	YY_BREAK
case 50:
YY_RULE_SETUP
return VARYING;
	YY_BREAK
case 51:
YY_RULE_SETUP
return SAMPLER2D;
	YY_BREAK
case 52:
YY_RULE_SETUP
return SAMPLERCUBE;
	YY_BREAK
case 53:
YY_RULE_SETUP
return STRUCT;
	YY_BREAK
case 54:
YY_RULE_SETUP
return _VOID;
	YY_BREAK
case 55:
YY_RULE_SETUP
return WHILE;
	YY_BREAK
case 56:
YY_RULE_SETUP
return INVARIANT;
	YY_BREAK
case 57:
YY_RULE_SETUP
return HIGH_PRECISION;
	YY_BREAK
case 58:
YY_RULE_SETUP
return MEDIUM_PRECISION;
	YY_BREAK
case 59:
YY_RULE_SETUP
return LOW_PRECISION;
	YY_BREAK
case 60:
YY_RULE_SETUP
return PRECISION;
	YY_BREAK
/*
      tokens for the shading language itself (punctuators)

      LEFT_OP RIGHT_OP
      INC_OP DEC_OP LE_OP GE_OP EQ_OP NE_OP
      LOGICAL_AND_OP LOGICAL_OR_OP LOGICAL_XOR_OP MUL_ASSIGN DIV_ASSIGN ADD_ASSIGN
      MOD_ASSIGN LEFT_ASSIGN RIGHT_ASSIGN AND_ASSIGN XOR_ASSIGN OR_ASSIGN
      SUB_ASSIGN
      LEFT_PAREN RIGHT_PAREN LEFT_BRACKET RIGHT_BRACKET LEFT_BRACE RIGHT_BRACE DOT
      COMMA COLON EQUAL SEMICOLON BANG DASH TILDE PLUS STAR SLASH PERCENT
      LEFT_ANGLE RIGHT_ANGLE BITWISE_OR_OP BITWISE_XOR_OP BITWISE_AND_OP QUESTION

      plus BCM2727 intrinsic functions
   */
case 61:
YY_RULE_SETUP
return LEFT_OP;
	YY_BREAK
case 62:
YY_RULE_SETUP
return RIGHT_OP;
	YY_BREAK
case 63:
YY_RULE_SETUP
return INC_OP;
	YY_BREAK
case 64:
YY_RULE_SETUP
return DEC_OP;
	YY_BREAK
case 65:
YY_RULE_SETUP
return LE_OP;
	YY_BREAK
case 66:
YY_RULE_SETUP
return GE_OP;
	YY_BREAK
case 67:
YY_RULE_SETUP
return EQ_OP;
	YY_BREAK
case 68:
YY_RULE_SETUP
return NE_OP;
	YY_BREAK
case 69:
YY_RULE_SETUP
return LOGICAL_AND_OP;
	YY_BREAK
case 70:
YY_RULE_SETUP
return LOGICAL_OR_OP;
	YY_BREAK
case 71:
YY_RULE_SETUP
return LOGICAL_XOR_OP;
	YY_BREAK
case 72:
YY_RULE_SETUP
return MUL_ASSIGN;
	YY_BREAK
case 73:
YY_RULE_SETUP
return DIV_ASSIGN;
	YY_BREAK
case 74:
YY_RULE_SETUP
return ADD_ASSIGN;
	YY_BREAK
case 75:
YY_RULE_SETUP
return MOD_ASSIGN;
	YY_BREAK
case 76:
YY_RULE_SETUP
return LEFT_ASSIGN;
	YY_BREAK
case 77:
YY_RULE_SETUP
return RIGHT_ASSIGN;
	YY_BREAK
case 78:
YY_RULE_SETUP
return AND_ASSIGN;
	YY_BREAK
case 79:
YY_RULE_SETUP
return XOR_ASSIGN;
	YY_BREAK
case 80:
YY_RULE_SETUP
return OR_ASSIGN;
	YY_BREAK
case 81:
YY_RULE_SETUP
return SUB_ASSIGN;
	YY_BREAK
case 82:
YY_RULE_SETUP
return LEFT_PAREN;
	YY_BREAK
case 83:
YY_RULE_SETUP
return RIGHT_PAREN;
	YY_BREAK
case 84:
YY_RULE_SETUP
return LEFT_BRACKET;
	YY_BREAK
case 85:
YY_RULE_SETUP
return RIGHT_BRACKET;
	YY_BREAK
case 86:
YY_RULE_SETUP
return LEFT_BRACE;
	YY_BREAK
case 87:
YY_RULE_SETUP
return RIGHT_BRACE;
	YY_BREAK
case 88:
YY_RULE_SETUP
return DOT;
	YY_BREAK
case 89:
YY_RULE_SETUP
return COMMA;
	YY_BREAK
case 90:
YY_RULE_SETUP
return COLON;
	YY_BREAK
case 91:
YY_RULE_SETUP
return EQUAL;
	YY_BREAK
case 92:
YY_RULE_SETUP
return SEMICOLON;
	YY_BREAK
case 93:
YY_RULE_SETUP
return BANG;
	YY_BREAK
case 94:
YY_RULE_SETUP
return DASH;
	YY_BREAK
case 95:
YY_RULE_SETUP
return TILDE;
	YY_BREAK
case 96:
YY_RULE_SETUP
return PLUS;
	YY_BREAK
case 97:
YY_RULE_SETUP
return STAR;
	YY_BREAK
case 98:
YY_RULE_SETUP
return SLASH;
	YY_BREAK
case 99:
YY_RULE_SETUP
return PERCENT;
	YY_BREAK
case 100:
YY_RULE_SETUP
return LEFT_ANGLE;
	YY_BREAK
case 101:
YY_RULE_SETUP
return RIGHT_ANGLE;
	YY_BREAK
case 102:
YY_RULE_SETUP
return BITWISE_OR_OP;
	YY_BREAK
case 103:
YY_RULE_SETUP
return BITWISE_XOR_OP;
	YY_BREAK
case 104:
YY_RULE_SETUP
return BITWISE_AND_OP;
	YY_BREAK
case 105:
YY_RULE_SETUP
return QUESTION;
	YY_BREAK
case 106:
YY_RULE_SETUP
return INTRINSIC_TEXTURE_2D_BIAS;
	YY_BREAK
case 107:
YY_RULE_SETUP
return INTRINSIC_TEXTURE_2D_LOD;
	YY_BREAK
case 108:
YY_RULE_SETUP
return INTRINSIC_TEXTURE_CUBE_BIAS;
	YY_BREAK
case 109:
YY_RULE_SETUP
return INTRINSIC_TEXTURE_CUBE_LOD;
	YY_BREAK
case 110:
YY_RULE_SETUP
return INTRINSIC_RSQRT;
	YY_BREAK
case 111:
YY_RULE_SETUP
return INTRINSIC_RCP;
	YY_BREAK
case 112:
YY_RULE_SETUP
return INTRINSIC_LOG2;
	YY_BREAK
case 113:
YY_RULE_SETUP
return INTRINSIC_EXP2;
	YY_BREAK
case 114:
YY_RULE_SETUP
return INTRINSIC_CEIL;
	YY_BREAK
case 115:
YY_RULE_SETUP
return INTRINSIC_FLOOR;
	YY_BREAK
case 116:
YY_RULE_SETUP
return INTRINSIC_SIGN;
	YY_BREAK
case 117:
YY_RULE_SETUP
return INTRINSIC_TRUNC;
	YY_BREAK
case 118:
YY_RULE_SETUP
return INTRINSIC_NEAREST;
	YY_BREAK
case 119:
YY_RULE_SETUP
return INTRINSIC_MIN;
	YY_BREAK
case 120:
YY_RULE_SETUP
return INTRINSIC_MAX;
	YY_BREAK
/*
      reserved keywords which generate an error

      ASM
      CLASS UNION ENUM TYPEDEF TEMPLATE THIS PACKED
      GOTO SWITCH DEFAULT
      INLINE NOINLINE VOLATILE PUBLIC STATIC EXTERN EXTERNAL INTERFACE FLAT
      LONG SHORT DOUBLE HALF FIXED UNSIGNED SUPERP
      INPUT OUTPUT
      HVEC2 HVEC3 HVEC4 DVEC2 DVEC3 DVEC4 FVEC2 FVEC3 FVEC4
      SAMPLER1D SAMPLER3D
      SAMPLER1DSHADOW SAMPLER2DSHADOW
      SAMPLER2DRECT SAMPLER3DRECT SAMPLER2DRECTSHADOW
      SIZEOF CAST
      NAMESPACE USING
   */
case 121:
YY_RULE_SETUP
return ASM;
	YY_BREAK
case 122:
YY_RULE_SETUP
return CLASS;
	YY_BREAK
case 123:
YY_RULE_SETUP
return UNION;
	YY_BREAK
case 124:
YY_RULE_SETUP
return ENUM;
	YY_BREAK
case 125:
YY_RULE_SETUP
return TYPEDEF;
	YY_BREAK
case 126:
YY_RULE_SETUP
return TEMPLATE;
	YY_BREAK
case 127:
YY_RULE_SETUP
return THIS;
	YY_BREAK
case 128:
YY_RULE_SETUP
return PACKED;
	YY_BREAK
case 129:
YY_RULE_SETUP
return GOTO;
	YY_BREAK
case 130:
YY_RULE_SETUP
return SWITCH;
	YY_BREAK
case 131:
YY_RULE_SETUP
return DEFAULT;
	YY_BREAK
case 132:
YY_RULE_SETUP
return _INLINE;
	YY_BREAK
case 133:
YY_RULE_SETUP
return NOINLINE;
	YY_BREAK
case 134:
YY_RULE_SETUP
return VOLATILE;
	YY_BREAK
case 135:
YY_RULE_SETUP
return PUBLIC;
	YY_BREAK
case 136:
YY_RULE_SETUP
return STATIC;
	YY_BREAK
case 137:
YY_RULE_SETUP
return EXTERN;
	YY_BREAK
case 138:
YY_RULE_SETUP
return EXTERNAL;
	YY_BREAK
case 139:
YY_RULE_SETUP
return INTERFACE;
	YY_BREAK
case 140:
YY_RULE_SETUP
return FLAT;
	YY_BREAK
case 141:
YY_RULE_SETUP
return LONG;
	YY_BREAK
case 142:
YY_RULE_SETUP
return SHORT;
	YY_BREAK
case 143:
YY_RULE_SETUP
return DOUBLE;
	YY_BREAK
case 144:
YY_RULE_SETUP
return HALF;
	YY_BREAK
case 145:
YY_RULE_SETUP
return FIXED;
	YY_BREAK
case 146:
YY_RULE_SETUP
return _UNSIGNED;
	YY_BREAK
case 147:
YY_RULE_SETUP
return SUPERP;
	YY_BREAK
case 148:
YY_RULE_SETUP
return INPUT;
	YY_BREAK
case 149:
YY_RULE_SETUP
return OUTPUT;
	YY_BREAK
case 150:
YY_RULE_SETUP
return HVEC2;
	YY_BREAK
case 151:
YY_RULE_SETUP
return HVEC3;
	YY_BREAK
case 152:
YY_RULE_SETUP
return HVEC4;
	YY_BREAK
case 153:
YY_RULE_SETUP
return DVEC2;
	YY_BREAK
case 154:
YY_RULE_SETUP
return DVEC3;
	YY_BREAK
case 155:
YY_RULE_SETUP
return DVEC4;
	YY_BREAK
case 156:
YY_RULE_SETUP
return FVEC2;
	YY_BREAK
case 157:
YY_RULE_SETUP
return FVEC3;
	YY_BREAK
case 158:
YY_RULE_SETUP
return FVEC4;
	YY_BREAK
case 159:
YY_RULE_SETUP
return SAMPLER1D;
	YY_BREAK
case 160:
YY_RULE_SETUP
return SAMPLER3D;
	YY_BREAK
case 161:
YY_RULE_SETUP
return SAMPLER1DSHADOW;
	YY_BREAK
case 162:
YY_RULE_SETUP
return SAMPLER2DSHADOW;
	YY_BREAK
case 163:
YY_RULE_SETUP
return SAMPLER2DRECT;
	YY_BREAK
case 164:
YY_RULE_SETUP
return SAMPLER3DRECT;
	YY_BREAK
case 165:
YY_RULE_SETUP
return SAMPLER2DRECTSHADOW;
	YY_BREAK
case 166:
YY_RULE_SETUP
return SIZEOF;
	YY_BREAK
case 167:
YY_RULE_SETUP
return CAST;
	YY_BREAK
case 168:
YY_RULE_SETUP
return NAMESPACE;
	YY_BREAK
case 169:
YY_RULE_SETUP
return USING;
	YY_BREAK
/*
      boolean constants, preprocessing number and identifier

      TRUE FALSE
      PPNUMBER
      IDENTIFIER
   */
case 170:
YY_RULE_SETUP
return _TRUE;
	YY_BREAK
case 171:
YY_RULE_SETUP
return _FALSE;
	YY_BREAK
case 172:
YY_RULE_SETUP
{
                          // Cast from double and then copy bits.
                          float f = (float)atof(pptext);
                          pptoken.f = *(const_float*)&f;
                          return PPNUMBERF;
                       }
	YY_BREAK
case 173:
YY_RULE_SETUP
{
                              // Base of 0 does automatic dec/oct/hex recognition.
                              pptoken.i = (const_int)strtol(pptext, (char**)NULL, 0);
                              return PPNUMBERI;
                           }
	YY_BREAK
case 174:
YY_RULE_SETUP
{
           pptoken.s = strdup_fast(pptext);
           return PPNUMBERU;
        }
	YY_BREAK
case 175:
YY_RULE_SETUP
{
           pptoken.s = glsl_intern(pptext, true);
           return IDENTIFIER;
        }
	YY_BREAK
/*
      C++ comment
   */
case 176:
YY_RULE_SETUP
return WHITESPACE;
	YY_BREAK
/*
      C comment
   */
case 177:
YY_RULE_SETUP
BEGIN(comment);
	YY_BREAK
case 178:
YY_RULE_SETUP
/* eat anything that's not a '*' */
	YY_BREAK
case 179:
YY_RULE_SETUP
/* eat up '*'s not followed by '/'s */
	YY_BREAK
case 180:
/* rule 180 can match eol */
YY_RULE_SETUP
g_LineNumber++;
	YY_BREAK
case 181:
YY_RULE_SETUP
{
                           BEGIN(INITIAL);
                           return WHITESPACE;
                        }
	YY_BREAK
case YY_STATE_EOF(comment):
glsl_compile_error(ERROR_LEXER_PARSER, 1, g_LineNumber, "unexpected end of file in comment");
	YY_BREAK
case 182:
YY_RULE_SETUP
{
           pptoken.s = strdup_fast(pptext);
           return UNKNOWN;
        }
	YY_BREAK
case 183:
YY_RULE_SETUP
ECHO;
	YY_BREAK
case YY_STATE_EOF(INITIAL):
	yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed ppin at a new source and called
			 * pplex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = ppin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( ppwrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * pptext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of pplex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					pprealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
#if defined (__CC_ARM) && !defined (ANDROID)
		assert(0);		// getc cause arm link problem.
#else		
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );
#endif

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			pprestart(ppin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) pprealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = (yy_start);

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 578 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 578 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 577);

	return yy_is_jam ? 0 : yy_current_state;
}

    static void yyunput (int c, register char * yy_bp )
{
	register char *yy_cp;

    yy_cp = (yy_c_buf_p);

	/* undo effects of setting up pptext */
	*yy_cp = (yy_hold_char);

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = (yy_n_chars) + 2;
		register char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		register char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

	(yytext_ptr) = yy_bp;
	(yy_hold_char) = *yy_cp;
	(yy_c_buf_p) = yy_cp;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;

	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					pprestart(ppin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( ppwrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve pptext */
	(yy_hold_char) = *++(yy_c_buf_p);

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 *
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void pprestart  (FILE * input_file )
{

	if ( ! YY_CURRENT_BUFFER ){
        ppensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            pp_create_buffer(ppin,YY_BUF_SIZE );
	}

	pp_init_buffer(YY_CURRENT_BUFFER,input_file );
	pp_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 *
 */
    void pp_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{

	/* TODO. We should be able to replace this entire function body
	 * with
	 *		pppop_buffer_state();
	 *		pppush_buffer_state(new_buffer);
     */
	ppensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	pp_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (ppwrap()) processing, but the only time this flag
	 * is looked at is after ppwrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void pp_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	ppin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 *
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE pp_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) ppalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in pp_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) ppalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in pp_create_buffer()" );

	b->yy_is_our_buffer = 1;

	pp_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with pp_create_buffer()
 *
 */
    void pp_delete_buffer (YY_BUFFER_STATE  b )
{

	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		ppfree((void *) b->yy_ch_buf  );

	ppfree((void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a pprestart() or at EOF.
 */
    static void pp_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;

	pp_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then pp_init_buffer was _probably_
     * called from pprestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = 0;

	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 *
 */
    void pp_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		pp_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *
 */
void pppush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	ppensure_buffer_stack();

	/* This block is copied from pp_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from pp_switch_to_buffer. */
	pp_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *
 */
void pppop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	pp_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		pp_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void ppensure_buffer_stack (void)
{
	int num_to_alloc;

	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)ppalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in ppensure_buffer_stack()" );

		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));

		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)pprealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in ppensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 *
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE pp_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;

	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) ppalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in pp_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	pp_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to pplex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 *
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       pp_scan_bytes() instead.
 */
YY_BUFFER_STATE pp_scan_string (yyconst char * yystr )
{

	return pp_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to pplex() will
 * scan from a @e copy of @a bytes.
 * @param bytes the byte buffer to scan
 * @param len the number of bytes in the buffer pointed to by @a bytes.
 *
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE pp_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;

	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) ppalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in pp_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = pp_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in pp_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up pptext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		pptext[ppleng] = (yy_hold_char); \
		(yy_c_buf_p) = pptext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		ppleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 *
 */
int ppget_lineno  (void)
{

    return pplineno;
}

/** Get the input stream.
 *
 */
FILE *ppget_in  (void)
{
        return ppin;
}

/** Get the output stream.
 *
 */
FILE *ppget_out  (void)
{
        return ppout;
}

/** Get the length of the current token.
 *
 */
int ppget_leng  (void)
{
        return ppleng;
}

/** Get the current token.
 *
 */

char *ppget_text  (void)
{
        return pptext;
}

/** Set the current line number.
 * @param line_number
 *
 */
void ppset_lineno (int  line_number )
{

    pplineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 *
 * @see pp_switch_to_buffer
 */
void ppset_in (FILE *  in_str )
{
        ppin = in_str ;
}

void ppset_out (FILE *  out_str )
{
        ppout = out_str ;
}

int ppget_debug  (void)
{
        return pp_flex_debug;
}

void ppset_debug (int  bdebug )
{
        pp_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from pplex_destroy(), so don't allocate here.
     */

    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    ppin = stdin;
    ppout = stdout;
#else
    ppin = (FILE *) 0;
    ppout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * pplex_init()
     */
    return 0;
}

/* pplex_destroy is for both reentrant and non-reentrant scanners. */
int pplex_destroy  (void)
{

    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		pp_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		pppop_buffer_state();
	}

	/* Destroy the stack itself. */
	ppfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * pplex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

#define YYTABLES_NAME "yytables"

static YY_BUFFER_STATE s_CurrentBufferState;

// When the lexer starts, set it to read the header.
void glsl_init_lexer(void)
{
   g_LineNumber = LINE_NUMBER_UNDEFINED;
   g_FileNumber = -1;

   g_ShaderSourceCurrentIndex = -1;
   s_CurrentBufferState = pp_scan_string(sampler_functions);
}

void glsl_term_lexer(void)
{
   pplex_destroy();
}

void * ppalloc (size_t bytes)
{
   uint32_t *result = (uint32_t *)glsl_fastmem_malloc(bytes + sizeof(uint32_t), true);

   result[0] = (uint32_t)bytes;

   return result + 1;
}

void * pprealloc (void * ptr, size_t bytes)
{
   size_t old_bytes = ptr ? (size_t)((uint32_t *)ptr)[-1] : 0;

   void *result = ppalloc(bytes);

   memcpy(result, ptr, bytes < old_bytes ? bytes : old_bytes);

   return result;
}

void ppfree (void * ptr) {
   /* Do nothing */
   UNUSED(ptr);
}

// When the current buffer is depleted, switch to the next string.
// Returning 1 causes the lexer to terminate; 0 causes it to try again.
// This allows you to switch buffers.
int ppwrap(void)
{
   // Delete current buffer.
   pp_delete_buffer(s_CurrentBufferState);

   g_LineNumber = 1;
   g_FileNumber++;

   /*
      after we've done the sampler functions, allow a #version command
   */

   if (g_ShaderSourceCurrentIndex == -1)
      glsl_directive_allow_version();

   /*
      when we're about to do the builtins, remove all macro definitions
   */

   if (g_ShaderSourceCurrentIndex == g_ShaderSourceCount)
      glsl_directive_reset_macros();

   /*
      Look to next buffer. We have

      g_ShaderSourceCurrentIndex                   string in progress
         -1                                           sampler functions
          0                                           first shader source
            :     :     :
          g_ShaderSourceCount-1                       last shader source
          g_ShaderSourceCount                         \n
          g_ShaderSourceCount+1                       last constant function
            :     :     :
          g_ShaderSourceCount+CONST_FUNCTION_COUNT    first constant function
   */

   while (g_ShaderSourceCurrentIndex <= g_ShaderSourceCount+CONST_FUNCTION_COUNT) {
      g_ShaderSourceCurrentIndex++;

      if (g_ShaderSourceCurrentIndex < g_ShaderSourceCount) {
         s_CurrentBufferState = pp_scan_string(g_ShaderSourceValues[g_ShaderSourceCurrentIndex]);
         return 0;
      } else if (g_ShaderSourceCurrentIndex == g_ShaderSourceCount) {
         s_CurrentBufferState = pp_scan_string("\n");
         return 0;
      } else {
         const char *body = constantFunctions[g_ShaderSourceCount+CONST_FUNCTION_COUNT-g_ShaderSourceCurrentIndex].u.function_instance.const_function_body;

#if defined(__CC_ARM)
#ifndef ANDROID
         if ((size_t)body & 0x20000000) {
            s_CurrentBufferState = pp_scan_string((const char *)((size_t)body & ~0x20000000));
#else
         if ((size_t)body & 0x40000000) {
            s_CurrentBufferState = pp_scan_string((const char *)((size_t)body & ~0x00000000));
#endif //ANDROID
#else
         if ((size_t)body & 0x80000000) {
            s_CurrentBufferState = pp_scan_string((const char *)((size_t)body & 0x7fffffff));
#endif
            return 0;
         }
      }
   }

   return 1;         // EOF
}

